#
#	MacDifference.make
#
# Macintosh MPW Makefile for the Eclectus Difference utility
# Copyright (C) 1992-96 Eclectus (D. John Anderson, Alan B. Harper).

# This file is part of the Eclectus integration utilities.

# Eclectus integration utilities are free software; you can redistribute
# it and/or modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 1, or
# (at your option) any later version.

# Eclectus integration utilities are distributed in the hope that they
# will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
# See the GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with the Eclectus integration utilities; see the file COPYING.
# If not, write to the Free Software Foundation, 675 Mass Ave, Cambridge,
# MA 02139, USA.

# This make file has the following targets
#
#		Clean:						Remove all derived files, create directories necessary for other targets below.
#
#		All/<no target>:	Difference and DifferenceDebug as fat tools*
#		Release:					Fat Difference
#		PPC:							PPC only Difference
#		68K:							68K only Difference
#		Debug							Fat DifferenceDebug*
#		DebugPPC:					PPC only DifferenceDebug*
#		Debug68K:					68K only DifferenceDebug*
#
#		Install:					Install fat Difference and DifferenceDebug*
#		InstallRelease:		Install fat Difference*
#		InstallPPC:				Install PPC Difference*
#		Install68K:				Install 68K Difference*
#		InstallDebug:			Install fat DifferenceDebug*
#		InstallDebugPPC:	Install PPC only DifferenceDebug*
#		InstallDebug68K:	Install 68K only DifferenceDebug*
#
#	*	The code for DifferenceDebug is not included in the standard distribution, since it is used
#		only to test the code. Write Alan Harper (aharper@dnai.com) if you have a need for this code.
#		Also, the Install... targets place the tools in {MPW}ECTools, which may not be where you
#		want them. Change BIN_DIR to adjust this.

MWCPPC_OPTIONS = 
	-d DF_MACHINE_MACINTOSH 
	-d DF_COMPILER_MW 
	-d DF_CHIP_PPC 
	-mapcr 
	-maxerrors 10 
	-once 
	-opt all 
	-proto strict 
	-r 
	-str readonly 
	-trigraphs on 
	-w full

MWC68K_OPTIONS = 
	-d DF_MACHINE_MACINTOSH 
	-d DF_COMPILER_MW 
	-d DF_CHIP_68K 
	-enum int 
	-mapcr 
	-maxerrors 10 
	-mbg off 
	-mc68020 
	-model codesmart 
	-once 
	-opt all 
	-proto strict 
	-r 
	-str pool 
	-sym off 
	-trigraphs on 
	-w full

ADDL_MWCPPC_OPTIONS = 

ADDL_MWC68K_OPTIONS = 

MWLINKPPC_OPTIONS = 
	-d 
	-c 'MPS ' 
	-t 'MPST'

MWLINK68K_OPTIONS = -mpwtool

MWLINKPPC_LIBS = 
	"{MWPPCLibraries}"MWMPWCRuntime.Lib 
	"{MWPPCLibraries}"'MPW ANSI.C.PPC.Lib' 
	"{MWPPCLibraries}"PPCToolLibs.o 
	"{SharedLibraries}"InterfaceLib 
	"{SharedLibraries}"MathLib 

MWLINK68K_LIBS = 
	"{MW68KLibraries}"MPWRuntime.68K.lib 
	"{MW68KLibraries}"'MPW ANSI (4i/8d) C.68K.Lib' 
	"{MW68KLibraries}"'MathLib68K (4i/8d).Lib' 
	"{MW68KLibraries}"ToolLibs.o 
	"{MW68KLibraries}"MacOS.Lib 

DERIVED_DIR = :DifferenceR.i

DERIVED_DEBUG_DIR = :DifferenceD.i

TOOL_NAME = Difference

DEBUG_TOOL_NAME = DifferenceDebug

INSTALL_AS_NAME = Difference

INSTALL_FROM_NAME = Difference

BIN_DIR = {MPW}ECTools

LOCAL_BIN_DIR = :MacTools

DIFFERENCE_TO_OBERISH_DIR = ::Oberish

H_FILES = 
	diff.h

DIFFERENCE_PPC_OBJS = 
	{DERIVED_DIR}:analyze.c.x 
	{DERIVED_DIR}:io.c.x 
	{DERIVED_DIR}:util.c.x 
	{DERIVED_DIR}:Difference.c.x 
	{DEBUG_PPC_OBJS}

DIFFERENCE_68K_OBJS = 
	{DERIVED_DIR}:analyze.c.o 
	{DERIVED_DIR}:io.c.o 
	{DERIVED_DIR}:util.c.o 
	{DERIVED_DIR}:Difference.c.o 
	{DEBUG_68K_OBJS}

DEBUG_PPC_OBJS =

DEBUG_68K_OBJS =

Release  Difference

All  Release Debug

PPC  Difference.PPC

68K  Difference.68K

Debug  DifferenceDebug

DebugPPC  DifferenceDebug.PPC

Debug68K  DifferenceDebug.68K

Difference  {DERIVED_DIR}:Difference

Difference.PPC  {DERIVED_DIR}:Difference.PPC

Difference.68K  {DERIVED_DIR}:Difference.68K

DifferenceDebug  
	Make -f MacDifference.make 
		-d DEBUG_PPC_OBJS="{DERIVED_DEBUG_DIR}:DebugMalloc.c.x" 
		-d DEBUG_68K_OBJS="{DERIVED_DEBUG_DIR}:DebugMalloc.c.o" 
		-d DERIVED_DIR="{DERIVED_DEBUG_DIR}" 
		-d ADDL_MWCPPC_OPTIONS="-d DF_DEBUG -i {DIFFERENCE_TO_OBERISH_DIR}" 
		-d ADDL_MWC68K_OPTIONS="-d DF_DEBUG -i {DIFFERENCE_TO_OBERISH_DIR}" 
		-d TOOL_NAME={DEBUG_TOOL_NAME} 
		{DERIVED_DEBUG_DIR}:{DEBUG_TOOL_NAME}

DifferenceDebug.PPC 
	Make -f MacDifference.make 
		-d DEBUG_PPC_OBJS="{DERIVED_DEBUG_DIR}:DebugMalloc.c.x" 
		-d DERIVED_DIR="{DERIVED_DEBUG_DIR}" 
		-d ADDL_MWCPPC_OPTIONS="-d DF_DEBUG -i {DIFFERENCE_TO_OBERISH_DIR}" 
		-d TOOL_NAME={DEBUG_TOOL_NAME} 
		{DERIVED_DEBUG_DIR}:{DEBUG_TOOL_NAME}.PPC

DifferenceDebug.68K 
	Make -f MacDifference.make 
		-d DEBUG_68K_OBJS="{DERIVED_DEBUG_DIR}:DebugMalloc.c.o" 
		-d DERIVED_DIR="{DERIVED_DEBUG_DIR}" 
		-d ADDL_MWC68K_OPTIONS="-d DF_DEBUG -i {DIFFERENCE_TO_OBERISH_DIR}" 
		-d TOOL_NAME={DEBUG_TOOL_NAME} 
		{DERIVED_DEBUG_DIR}:{DEBUG_TOOL_NAME}.68K

{DIFFERENCE_PPC_OBJS}  {H_FILES}

{DIFFERENCE_68K_OBJS}  {H_FILES}

{DERIVED_DIR}:  :

{DERIVED_DIR}:  {DIFFERENCE_TO_OBERISH_DIR}:

{DERIVED_DIR}:{TOOL_NAME}  {DERIVED_DIR}:{TOOL_NAME}.PPC {DERIVED_DIR}:{TOOL_NAME}.68K
	Duplicate -y {DERIVED_DIR}:{TOOL_NAME}.PPC {DERIVED_DIR}:{TOOL_NAME}
	Rez -append -o {DERIVED_DIR}:{TOOL_NAME} -d RSRCNAME=""{DERIVED_DIR}:{TOOL_NAME}.68K"" MacCopyRSRC.r

{DERIVED_DIR}:{TOOL_NAME}.PPC   {DIFFERENCE_PPC_OBJS}
	MWLinkPPC {MWLINKPPC_LIBS} {DIFFERENCE_PPC_OBJS} {MWLINKPPC_OPTIONS} -o {Targ}
	Rez -d APPNAME="{TOOL_NAME}" MacGenericCFRG.r -o {Targ}

{DERIVED_DIR}:{TOOL_NAME}.68K   {DIFFERENCE_68K_OBJS}
	MWLink68K {MWLINK68K_LIBS} {DIFFERENCE_68K_OBJS} {MWLINK68K_OPTIONS} -o {Targ}

Install  InstallRelease InstallDebug

InstallRelease  {DERIVED_DIR}:{INSTALL_FROM_NAME}
	If not `Exists {BIN_DIR}:`
		NewFolder {BIN_DIR}:
	End
	Duplicate -y {DERIVED_DIR}:{INSTALL_FROM_NAME} {BIN_DIR}:{INSTALL_AS_NAME}
	If not `Exists {LOCAL_BIN_DIR}:`
		NewFolder {LOCAL_BIN_DIR}:
	End
	Duplicate -y {DERIVED_DIR}:{INSTALL_FROM_NAME} {LOCAL_BIN_DIR}:{INSTALL_AS_NAME}.mpw

InstallPPC 
	Make -f MacDifference.make InstallRelease 
		-d INSTALL_FROM_NAME="Difference.PPC" 
		-d TOOL_NAME="Difference"

Install68K 
	Make -f MacDifference.make InstallRelease 
		-d INSTALL_FROM_NAME="Difference.68K" 
		-d TOOL_NAME="Difference"

InstallDebug 
	Make -f MacDifference.make InstallRelease 
		-d ADDL_MWCPPC_OPTIONS="-d DF_DEBUG -i {DIFFERENCE_TO_OBERISH_DIR}" 
		-d ADDL_MWC68K_OPTIONS="-d DF_DEBUG -i {DIFFERENCE_TO_OBERISH_DIR}" 
		-d DEBUG_PPC_OBJS="{DERIVED_DEBUG_DIR}:DebugMalloc.c.x" 
		-d DEBUG_68K_OBJS="{DERIVED_DEBUG_DIR}:DebugMalloc.c.o" 
		-d DERIVED_DIR="{DERIVED_DEBUG_DIR}" 
		-d INSTALL_FROM_NAME="DifferenceDebug" 
		-d INSTALL_AS_NAME="DifferenceDebug" 
		-d TOOL_NAME="DifferenceDebug"

InstallDebugPPC 
	Make -f MacDifference.make InstallRelease 
		-d ADDL_MWCPPC_OPTIONS="-d DF_DEBUG -i {DIFFERENCE_TO_OBERISH_DIR}" 
		-d DEBUG_PPC_OBJS="{DERIVED_DEBUG_DIR}:DebugMalloc.c.x" 
		-d DERIVED_DIR="{DERIVED_DEBUG_DIR}" 
		-d INSTALL_FROM_NAME="DifferenceDebug.PPC" 
		-d INSTALL_AS_NAME="DifferenceDebug" 
		-d TOOL_NAME="DifferenceDebug"

InstallDebug68K 
	Make -f MacDifference.make InstallRelease 
		-d ADDL_MWC68K_OPTIONS="-d DF_DEBUG -i {DIFFERENCE_TO_OBERISH_DIR}" 
		-d DEBUG_68K_OBJS="{DERIVED_DEBUG_DIR}:DebugMalloc.c.o" 
		-d DERIVED_DIR="{DERIVED_DEBUG_DIR}" 
		-d INSTALL_FROM_NAME="DifferenceDebug.68K" 
		-d INSTALL_AS_NAME="DifferenceDebug" 
		-d TOOL_NAME="DifferenceDebug"

Clean 
	Delete -y -i {DERIVED_DIR}
	NewFolder {DERIVED_DIR}
	Delete -y -i {DERIVED_DEBUG_DIR}
	NewFolder {DERIVED_DEBUG_DIR}

.c.x  .c
	MWCPPC {MWCPPC_OPTIONS} {ADDL_MWCPPC_OPTIONS} {DepDir}{Default}.c -o {Targ}

.c.o  .c
	MWC68K {MWC68K_OPTIONS} {ADDL_MWC68K_OPTIONS} {DepDir}{Default}.c -o {Targ}
