/****************************************************************************
 * 
 * AppleEvent.h
 * 
 * Functions related to processing AppleEvents and dispatching to the appropriate handlers
 *
 ****************************************************************************/

#ifndef __APPLEEVENT__
#define __APPLEEVENT__

// --------------------------------------------------------------------------

Boolean			InstallAEHandlers						(void);
Boolean  		InstallOtherEventHandlers			(void);

Boolean			HasAppleEvents							(void);

Boolean			HasUnhandledParameters				(AppleEvent* appleEvent);
OSErr				StuffErrorNumberIntoReply			(OSErr err, AppleEvent* reply);

pascal OSErr 	HandleEveryOtherAppleEvent			(AppleEvent *appleEvent, AppleEvent *reply, long refCon);

OSErr 			CheckForUnusedParameters			(const AppleEvent* appleEvent);

OSErr 			PutReplyErrorNumber					(AppleEvent* reply, long errorNumber);
OSErr 			PutReplyErrorMessage					(AppleEvent* reply, char *message);

OSErr				GetObjectClassFromAppleEvent		(const AppleEvent *appleEvent, DescType *typeOfObject);

// --------------------------------------------------------------------------
 
 #endif
